org.opencv.structured_light

## Class GrayCodePattern

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.structured_light.StructuredLightPattern
    - - org.opencv.structured_light.GrayCodePattern

-     public class GrayCodePattern
      extends StructuredLightPattern

  Class implementing the Gray-code pattern, based on CITE: UNDERWORLD. The generation of the pattern images is performed with Gray encoding using the traditional white and black colors. The information about the two image axes x, y is encoded separately into two different pattern sequences. A projector P with resolution (P_res_x, P_res_y) will result in Ncols = log 2 (P_res_x) encoded pattern images representing the columns, and in Nrows = log 2 (P_res_y) encoded pattern images representing the rows. For example a projector with resolution 1024x768 will result in Ncols = 10 and Nrows = 10. However, the generated pattern sequence consists of both regular color and color-inverted images: inverted pattern images are images with the same structure as the original but with inverted colors. This provides an effective method for easily determining the intensity value of each pixel when it is lit (highest value) and when it is not lit (lowest value). So for a a projector with resolution 1024x768, the number of pattern images will be Ncols * 2 + Nrows * 2 = 40.

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `GrayCodePattern(long addr)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static GrayCodePattern` | `__fromPtr__(long addr)`
    `static GrayCodePattern` | `create(int width, int height)` Constructor
    `protected void` | `finalize()`
    `void` | `getImagesForShadowMasks(Mat blackImage, Mat whiteImage)` Generates the all-black and all-white images needed for shadowMasks computation.
    `long` | `getNumberOfPatternImages()` Get the number of pattern images needed for the graycode pattern.
    `boolean` | `getProjPixel(List<Mat> patternImages, int x, int y, Point projPix)` For a (x,y) pixel of a camera returns the corresponding projector pixel.
    `void` | `setBlackThreshold(long value)` Sets the value for black threshold, needed for decoding (shadowsmasks computation).
    `void` | `setWhiteThreshold(long value)` Sets the value for white threshold, needed for decoding.

    - ### Methods inherited from class org.opencv.structured_light.StructuredLightPattern

      `generate`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, empty, getDefaultName, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GrayCodePattern

          protected GrayCodePattern(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static GrayCodePattern __fromPtr__(long addr)

    - #### create

          public static GrayCodePattern create(int width,
                                               int height)

      Constructor
      Parameters:
        `width` - automatically generated
        `height` - automatically generated
      Returns:
        automatically generated

    - #### getProjPixel

          public boolean getProjPixel(List<Mat> patternImages,
                                      int x,
                                      int y,
                                      Point projPix)

      For a (x,y) pixel of a camera returns the corresponding projector pixel. The function decodes each pixel in the pattern images acquired by a camera into their corresponding decimal numbers representing the projector's column and row, providing a mapping between camera's and projector's pixel.
      Parameters:
        `patternImages` - The pattern images acquired by the camera, stored in a grayscale vector < Mat >.
        `x` - x coordinate of the image pixel.
        `y` - y coordinate of the image pixel.
        `projPix` - Projector's pixel corresponding to the camera's pixel: projPix.x and projPix.y are the image coordinates of the projector's pixel corresponding to the pixel being decoded in a camera.
      Returns:
        automatically generated

    - #### getNumberOfPatternImages

          public long getNumberOfPatternImages()

      Get the number of pattern images needed for the graycode pattern.
      Returns:
        The number of pattern images needed for the graycode pattern.

    - #### getImagesForShadowMasks

          public void getImagesForShadowMasks(Mat blackImage,
                                              Mat whiteImage)

      Generates the all-black and all-white images needed for shadowMasks computation. To identify shadow regions, the regions of two images where the pixels are not lit by projector's light and thus where there is not coded information, the 3DUNDERWORLD algorithm computes a shadow mask for the two cameras views, starting from a white and a black images captured by each camera. This method generates these two additional images to project.
      Parameters:
        `blackImage` - The generated all-black CV_8U image, at projector's resolution.
        `whiteImage` - The generated all-white CV_8U image, at projector's resolution.

    - #### setBlackThreshold

          public void setBlackThreshold(long value)

      Sets the value for black threshold, needed for decoding (shadowsmasks computation). Black threshold is a number between 0-255 that represents the minimum brightness difference required for valid pixels, between the fully illuminated (white) and the not illuminated images (black); used in computeShadowMasks method.
      Parameters:
        `value` - The desired black threshold value.

    - #### setWhiteThreshold

          public void setWhiteThreshold(long value)

      Sets the value for white threshold, needed for decoding. White threshold is a number between 0-255 that represents the minimum brightness difference required for valid pixels, between the graycode pattern and its inverse images; used in getProjPixel method.
      Parameters:
        `value` - The desired white threshold value.

    - #### finalize

          protected void finalize()
                           throws Throwable

      Overrides:
        `finalize` in class `StructuredLightPattern`
      Throws:
        `Throwable`

Generated on Wed Oct 9 2019 16:55:37 UTC / OpenCV 3.4.8